:i	static char str_misc_sccs_id[] = "%W% %G%";
#include "V_M.h"
#include "str.h"
#include "mem.h"

#ifdef NOTNOW
/*
* Find common substring.  Compare the first n  bytes  of  two  null-terminated
* strings,  and return the length of the common initial substring.  The result
* will be in [0,n].
*/
comstrn(p,q,n)
	char *p;
	char *q;
	Sizt  n;
{	Sizt  i;

	for (i=0; i<n; i++)
		if (p[i] != q[i])
			return i;
	return n;
}
/*
* Allocate space for a copy of a null-terminated string, copy it  to  the  new
* block,  and  return  its  address.   The  msg  is  for diagnostics.  This is
* essentiall a clone of the library dupstr() function.
*/
char *
dupstr(p,m)
	char *p;
	char *m;
{	char *q;
	Sizt  n;

:f	Fenter("dupstr");
	if (!m) m = p;
	n = strlen(p) + StrPadLen;
	if (q = (CP)GetChunk(MEMUNIT(n),m)) {
:9		V9M "Got %d bytes  for %s.",n+StrPadLen,m D;
		Bcopy(p, q, n);
:9		V9M "Put %d bytes into %s.",n+StrPadLen,m D;
	}
:f	Fexit;
	return q;
}
#endif

/*
* Here are some older names for some of our  functions,  kept  for  the  usual
* backwards  compatibiliity  reasons,  so that we can successfully link old .o
* files to this newer version of the str package.
*/
int  chkstrng(s,m) Str*s; char*m; {return str_chksm(s,m);}
Str* appstrng(d,s,l,m) Str*d; char*s; char*m; {return str_appscm(d,s,l,m);}
Str* cpystrng(d,s,m) Str*d; Str*s; char*m; {return str_dupssm(d,s,m);}
Str* dupstrng(d,s,m) Str*d; Str*s; char*m; {return str_dupssm(d,s,m);}
Str* freestrng(s,m) Str*s; char*m; {return str_zapsm(s,m);}
Str* getstrng(s,n,m) Str*s; char*m; {return str_dupscm(s,(char*)0,n,m);}
Str* makstrng(d,s,l,m) Str*d; char*s; char*m; {return str_dupscm(d,s,l,m);}
