#ifndef sys_wait_h

#ifndef   sys_types_h
#include	"sys_types.h"
#endif

#if !defined(sys_wait_h) && defined(OSF1)
/*
* Under OSF1, `man wait` describes wait3() and wait4() as well as  the
* union  wait,  but  if  you  try  to compile with -std1 to get ANSI C
* definitions, union wait doesn't  get  defined  and  wait3()  doesn't
* work.   The  wait.h file is baffling, so until we learn how to do it
* right, the best thing is to just use wait() and int status.
*/
static char sys_wait_id[] = "OSF1";
#include	<sys/wait.h>
#define sys_wait_h	1
#define HAS_wait	1
#define USE_wait	1
#define HAS_wait3	1
#define USE_wait3	0
#define USE_waitint	1
#define USE_waitstruct	0
#endif

#if !defined(sys_wait_h) && defined(AIX)
#include	<sys/wait.h>
#define sys_wait_h	1
#define HAS_wait	1
#define USE_wait	1
#define HAS_wait3	0
#define USE_wait3		0
#define USE_waitint	1
#define USE_waitstruct	0
#endif

#if !defined(sys_wait_h) && defined(ESIX4)
#include	<wait.h>
#define sys_wait_h	1
#define USE_waitstruct	1
#define USE_waitint	0
#endif

#if !defined(sys_wait_h) && defined(SOLARIS)
#include	<sys/wait.h>
#define sys_wait_h	1
#define USE_waitstruct	0
#define USE_waitint	1
#endif

#if !defined(sys_wait_h) && defined(SUN4)
#include	<sys/wait.h>
#define sys_wait_h	1
#define USE_waitstruct	1
#define USE_waitint	0
#endif

#endif
